/*
 * Simple Ogg Vorbis decoder, (c) 2009 WWRN Vincent B Washington
 *
 * Based in part on the original sample ogg vorbis decoder - structure is
 * designed for reuse.
 *
 * Incorporates code (c) 2004 BBC Michael Sparks
 * Incorporates code (c) 1994-2004 XIPHOPHORUS Company http://www.xiph.org/
 *
 * Important limitations include:
 *   * Has a minimum buffer size of 58 bytes (important detail)
 *   <*> This is a oggvorbis design feature
 *
 *   * Does not handle chained bitstreams.
 *     (Multiple vorbis streams concatenated in a file)
 *   * Need to figure out where to place ogg_page_eos()
 *
 *   * Uses EOF to indicate end of stream
 *   <*> Uses empty sourceBuffer to ene stream
 *
 * Seems to decode most ogg vorbis file pretty well though
 *
 */

		/* Compile, Link, And Biuld Usig THESE */

//  [Primary] [ g++ -I /usr/local/include -O20 -ffast-math -mno-ieee-fp -fsigned-char  -c StateMachine.c oggvorbis_StateMachine.c ]
//  [Optional Varible] -D PRINT_TIMING_SEQUENCE Use to determine input and output to the StateMachine
//  [Primary] [ g++ -O20 -ffast-math -mno-ieee-fp -fsigned-char -l vorbis -lm -logg -o Pcmout StateMachine.o oggvorbis_StateMachine.c ]
//  [To play] [./Pcmout <OggVorbisTest.ogg | aplay -fcd -]

/*
 *  [Optional Multidef] g++ -O20 -ffast-math -mno-ieee-fp -fsigned-char -l vorbis -lm -logg -Xlinker -zmuldefs -o Pcmout StateMachine.c
 *                      oggvorbis_tateMachine.c
 */


#include <iostream>
#include "oggvorbis_StateMachine.h"

int main(int argc, char *argv[]) {

   DigitalWordProcessor();

return 0;
}


goNogo DigitalWordProcessor(void)
{

   #ifdef PRINT_TIMING_SEQUENCE 
   FILE *DNULL=fopen("/dev/null", "w");
   DigitalWordRegisterSchdule = fopen("DigitalWordRegisterSchdule", "w");
   #endif

   if ((StateMachine = (Machine *)malloc(sizeof(Machine))) == NULL)
   	return 1;
   {
	memset(StateMachine, 0, sizeof(StateMachine));
	StateMachine->CallRoutine[1] = recycle;
	StateMachine->CallRoutine[2] = getDATA;
	StateMachine->CallRoutine[3] = sendDATA;
	StateMachine->CallRoutine[4] = initCALL;
	StateMachine->CallRoutine[5] = processAudio;
	StateMachine->CallRoutine[6] = Commence;
	StateMachine->CallRoutine[7] = OggVorbisVerificationTest;
	StateMachine->CallRoutine[8] = CodeBookAndPreMetaData;
	StateMachine->CallRoutine[9] = AudioPacketDecodeSynthesis;
   }

   DigitalWordRegister = DigitalBit4;

   while(DigitalWordRegister & ETLADECODING) {
	#ifdef PRINT_TIMING_SEQUENCE
	fprintf(stderr, "Routine IN THE REGISTRA [0x%X]\n", DigitalWordRegister);
	#endif
	StateMachine->CallRoutine[LookUpTable(DigitalWordRegister & ETLADECODING)]();
	#ifdef PRINT_TIMING_SEQUENCE
 	fprintf(stderr, "Routine FROM STATE FUNCTION [0x%X]\n", DigitalWordRegister);
	#endif
   }
   #ifdef PRINT_TIMING_SEQUENCE
   fclose(DNULL);
   fclose(DigitalWordRegisterSchdule);
   #endif
   ogg_sync_clear(&(oggVorbisBlackBox->oggSync));
   free(StateMachine);
   free(sourceBuffer);
   free(oggVorbisBlackBox);
   return 0;
}
